using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;
using System.Net;
using System.Threading;
using System.IO;

namespace HCComSrv
{
    class Program
    {
        static Socket _serv;

        static void Main(string[] args)
        {
            byte[] tmp = new byte[1024];
            IPEndPoint ponto = new IPEndPoint(IPAddress.Any, Properties.Settings.Default.Porta);
            uint totalSessoes = 0;
            _serv = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            _serv.Bind(ponto);
            Properties.Settings.Default.Save();
            Console.WriteLine("HCComSrv");
            Console.WriteLine("Config..: " + System.Configuration.ConfigurationManager.OpenExeConfiguration(System.Configuration.ConfigurationUserLevel.None).FilePath);
            string dirEndereco = Properties.Settings.Default.Diretorio;
            if (dirEndereco.ToUpper() == "[HCCOM]") dirEndereco = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.CommonApplicationData), "HCCOM");
            if (!Directory.Exists(dirEndereco))
            {
                Directory.CreateDirectory(dirEndereco);
                File.WriteAllText(Path.Combine(dirEndereco, "index.rmd"), @"@title=HCComSrv
# Servidor HCCom

Substitua este arquivo com o contedo do ndice deste servidor.

Este arquivo usa a especificao RetroMarkDown");
            }
            Console.WriteLine("Dados...: " + dirEndereco);
            DirectoryInfo dir = new DirectoryInfo(dirEndereco);
            Console.WriteLine("Pressione Ctrl+C para interromper");
            Dictionary<string, Stream> fluxos = new Dictionary<string, Stream>();
            Dictionary<string, ushort> posicoes = new Dictionary<string, ushort>();
            Dictionary<string, DateTime> acessos = new Dictionary<string, DateTime>();
            while (true)
            {
                if (_serv.Available > 0)
                {
                    string chave = "";
                    Pacote pac = new Pacote();
                    try
                    {
                        foreach (KeyValuePair<string, DateTime> acesso in acessos)
                        {
                            if (acesso.Value.AddSeconds(5) < DateTime.Now)
                            {
                                fluxos.Remove(acesso.Key);
                                posicoes.Remove(acesso.Key);
                                acessos.Remove(acesso.Key);
                            }
                        }

                        EndPoint remoto = (EndPoint)new IPEndPoint(IPAddress.Any, 0);
                        if (pac.Receber(_serv, ref remoto))
                        {
                            chave = remoto.ToString();
                            if (pac.Comando == Comandos.Processado)
                            {
                                if (fluxos.ContainsKey(remoto.ToString()))
                                {
                                    if (posicoes[chave] == pac.LerNumero(0))
                                    {
                                        posicoes[chave]++;
                                        acessos[chave] = DateTime.Now;
                                        tmp = new byte[512];
                                        int tam = fluxos[chave].Read(tmp, 0, 512);
                                        if (tam < 512) Array.Resize<byte>(ref tmp, tam);
                                        Pacote.GerarDados(posicoes[chave], tmp).Enviar(_serv, (IPEndPoint)remoto);
                                        if (tam < 512)
                                        {
                                            fluxos[chave].Close();
                                            fluxos.Remove(chave);
                                            posicoes.Remove(chave);
                                            acessos.Remove(chave);
                                        }
                                    }
                                }
                                else
                                {
                                    Pacote.GerarErro(pac.LerNumero(0), "Fluxo inexistente.").Enviar(_serv, (IPEndPoint)remoto);
                                }
                            }
                            else if (pac.Comando == Comandos.RequisicaoDeLeitura)
                            {
                                totalSessoes++;
                                if (uint.MaxValue == totalSessoes)
                                {
                                    totalSessoes = 0;
                                }
                                List<byte> arquivoByte = new List<byte>();
                                foreach (byte c in pac.Dados)
                                {
                                    if (c == 0) break;
                                    arquivoByte.Add(c);
                                }
                                string arquivo = Encoding.UTF8.GetString(arquivoByte.ToArray());
                                arquivo = arquivo.Replace("\\", "/").Replace("..", "");
                                while (arquivo.StartsWith("/"))
                                {
                                    arquivo = arquivo.Substring(1);
                                }
                                arquivo = Path.Combine(dir.FullName, arquivo.Replace('/', Path.DirectorySeparatorChar));

                                bool ok = true;
                                if (File.Exists(arquivo))
                                {
                                    if (fluxos.ContainsKey(chave))
                                    {
                                        Pacote.GerarErro(1, "Apenas um canal simultaneo pode ser aberto a partir da mesma porta.").Enviar(_serv, (IPEndPoint)remoto);
                                        ok = false;
                                    }
                                    else
                                    {
                                        fluxos.Add(chave, new FileStream(arquivo, FileMode.Open));
                                        posicoes.Add(chave, 1);
                                        acessos.Add(chave, DateTime.Now);
                                    }
                                }
                                else if (Directory.Exists(Path.GetDirectoryName(arquivo)) & Path.GetFileName(arquivo) == "dir")
                                {
                                    MemoryStream fluxo = new MemoryStream();
                                    DirectoryInfo dirInfo = new DirectoryInfo(Path.GetDirectoryName(arquivo));
                                    byte[] nomeBytes;
                                    foreach (DirectoryInfo item in dirInfo.GetDirectories())
                                    {
                                        tmp = new byte[64];
                                        tmp[0] = 10;
                                        tmp[1] = 0;
                                        tmp[2] = 0;
                                        nomeBytes = Encoding.UTF8.GetBytes(item.Name);
                                        Array.Copy(nomeBytes, 0, tmp, 3, nomeBytes.Length > 60 ? 60 : nomeBytes.Length);
                                        tmp[59] = 0;
                                        fluxo.Write(tmp, 0, 64);
                                    }
                                    foreach (FileInfo item in dirInfo.GetFiles())
                                    {
                                        tmp = new byte[64];
                                        tmp[0] = 20;
                                        tmp[1] = 0;
                                        tmp[2] = 0;
                                        nomeBytes = Encoding.UTF8.GetBytes(item.Name);
                                        Array.Copy(nomeBytes, 0, tmp, 3, nomeBytes.Length > 60 ? 60 : nomeBytes.Length);
                                        tmp[59] = 0;
                                        fluxo.Write(tmp, 0, 64);
                                    }
                                    fluxo.Seek(0, SeekOrigin.Begin);
                                    fluxos.Add(chave, fluxo);
                                    acessos.Add(chave, DateTime.Now);
                                    posicoes.Add(chave, 1);
                                }
                                else
                                {
                                    ok = false;
                                    Pacote.GerarErro(1, "Arquivo solicitado no existe").Enviar(_serv, (IPEndPoint)remoto);
                                }
                                if (ok)
                                {
                                    tmp = new byte[512];
                                    int tam = fluxos[chave].Read(tmp, 0, 512);
                                    if (tam < 512) Array.Resize<byte>(ref tmp, tam);
                                    Pacote.GerarDados(1, tmp).Enviar(_serv, (IPEndPoint)remoto);
                                }
                            }
                        }
                    }
                    catch(Exception ex)
                    {
                        Console.WriteLine("Erro na sessao " + chave + ": " + ex.Message);
                    }
                }

                if (Console.KeyAvailable)
                {
                    ConsoleKeyInfo tecla = Console.ReadKey();
                    if (tecla.Modifiers == ConsoleModifiers.Control & tecla.Key == ConsoleKey.C)
                    {
                        break;
                    }
                    else if (tecla.Key == ConsoleKey.I)
                    {
                        Console.WriteLine("{0} Sesses ativas. " + Environment.NewLine + "{1} Sesses desde a ultima reinicializao.", fluxos.Count, totalSessoes);
                    }
                }
                Thread.Sleep(50);
            }
            _serv.Close();
        }
    }

    class Pacote
    {
        private byte[] _dados;

        public byte[] Dados
        {
            get { return _dados; }
            set { _dados = value; }
        }

        private Comandos _comando;

        public Comandos Comando
        {
            get { return _comando; }
            set { _comando = value; }
        }

        public ushort LerNumero(int pos)
        {
            return (ushort)((Dados[pos] << 8) & 0xff00 | Dados[pos + 1]);
        }

        private static string converterModo(Modos modo)
        {
            switch (modo)
            {
                case Modos.Desconhecido:
                    return "";
                case Modos.Texto:
                    return "netascii";
                case Modos.Binario:
                    return "octet";
                case Modos.Email:
                    return "mail";
                default:
                    return "";
            }
        }

        public static Pacote GerarRequisicaoDeLeitura(string arquivo, Modos modo)
        {
            Pacote ret = new Pacote();
            ret.Comando = Comandos.RequisicaoDeLeitura;
            List<byte> conteudo = new List<byte>();
            conteudo.AddRange(Encoding.UTF8.GetBytes(arquivo));
            conteudo.Add(0);
            conteudo.AddRange(Encoding.UTF8.GetBytes(converterModo(modo)));
            conteudo.Add(0);
            ret.Dados = conteudo.ToArray();
            return ret;
        }

        public static Pacote GerarRequisicaoDeGravacao(string arquivo, Modos modo)
        {
            Pacote ret = new Pacote();
            ret.Comando = Comandos.RequisicaoDeGravacao;
            List<byte> conteudo = new List<byte>();
            conteudo.AddRange(Encoding.UTF8.GetBytes(arquivo));
            conteudo.Add(0);
            conteudo.AddRange(Encoding.UTF8.GetBytes(converterModo(modo)));
            conteudo.Add(0);
            ret.Dados = conteudo.ToArray();
            return ret;
        }

        public static Pacote GerarDados(ushort posicao, byte[] dados)
        {
            Pacote ret = new Pacote();
            ret.Comando = Comandos.Dados;
            List<byte> conteudo = new List<byte>();
            conteudo.Add((byte)((posicao >> 8) & 0xff));
            conteudo.Add((byte)(posicao & 0xff));
            conteudo.AddRange(dados);
            ret.Dados = conteudo.ToArray();
            return ret;
        }

        public static Pacote GerarErro(ushort posicao, string mensagem)
        {
            Pacote ret = new Pacote();
            ret.Comando = Comandos.Erro;
            List<byte> conteudo = new List<byte>();
            conteudo.Add((byte)((posicao >> 8) & 0xff));
            conteudo.Add((byte)(posicao & 0xff));
            conteudo.AddRange(Encoding.UTF8.GetBytes(mensagem));
            conteudo.Add(0);
            ret.Dados = conteudo.ToArray();
            return ret;
        }

        public static Pacote GerarProcessado(ushort posicao)
        {
            Pacote ret = new Pacote();
            ret.Comando = Comandos.Processado;
            List<byte> conteudo = new List<byte>();
            conteudo.Add((byte)((posicao >> 8) & 0xff));
            conteudo.Add((byte)(posicao & 0xff));
            ret.Dados = conteudo.ToArray();
            return ret;
        }

        public void Enviar(Socket conexao, IPEndPoint servidor)
        {
            List<byte> pacote = new List<byte>();
            pacote.Add(0);
            pacote.Add((byte)Comando);
            pacote.AddRange(Dados);
            conexao.SendTo(pacote.ToArray(), pacote.Count, SocketFlags.None, servidor);
        }

        public bool Receber(Socket conexao, ref EndPoint servidor)
        {
            try
            {
                byte[] tmp = new byte[1024];
                int tam = conexao.ReceiveFrom(tmp, ref servidor);
                Comando = (Comandos)tmp[1];
                Dados = new byte[tam - 2];
                Array.Copy(tmp, 2, Dados, 0, tam - 2);
                return true;
            }
            catch (Exception)
            {
                return false;
            }
        }
    }

    enum Comandos
    {
        Desconhecido = 0,
        RequisicaoDeLeitura = 1,
        RequisicaoDeGravacao = 2,
        Dados = 3,
        Processado = 4,
        Erro = 5
    }

    enum Modos
    {
        Desconhecido = 0,
        Texto = 1,
        Binario = 2,
        Email = 3
    }
}
